Merge branch 'stable-2.8' into stable-2.9
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # Note: these are automake-specific variables, and must be named after
44 # the directory + 'dir' suffix
45 clientdir = $(pkgpythondir)/client
46 cmdlibdir = $(pkgpythondir)/cmdlib
47 hypervisordir = $(pkgpythondir)/hypervisor
48 storagedir = $(pkgpythondir)/storage
49 httpdir = $(pkgpythondir)/http
50 masterddir = $(pkgpythondir)/masterd
51 confddir = $(pkgpythondir)/confd
52 rapidir = $(pkgpythondir)/rapi
53 serverdir = $(pkgpythondir)/server
54 watcherdir = $(pkgpythondir)/watcher
55 impexpddir = $(pkgpythondir)/impexpd
56 utilsdir = $(pkgpythondir)/utils
57 toolsdir = $(pkglibdir)/tools
58 iallocatorsdir = $(pkglibdir)/iallocators
59 pytoolsdir = $(pkgpythondir)/tools
60 docdir = $(datadir)/doc/$(PACKAGE)
61 myexeclibdir = $(pkglibdir)
62
63 # Delete output file if an error occurred while building it
64 .DELETE_ON_ERROR:
65
66 HS_DIRS = \
67         src \
68         src/Ganeti \
69         src/Ganeti/Confd \
70         src/Ganeti/Curl \
71         src/Ganeti/DataCollectors \
72         src/Ganeti/HTools \
73         src/Ganeti/HTools/Backend \
74         src/Ganeti/HTools/Program \
75         src/Ganeti/Hypervisor \
76         src/Ganeti/Hypervisor/Xen \
77         src/Ganeti/Monitoring \
78         src/Ganeti/Query \
79         src/Ganeti/Storage \
80         src/Ganeti/Storage/Diskstats \
81         src/Ganeti/Storage/Drbd \
82         src/Ganeti/Storage/Lvm \
83         test/hs \
84         test/hs/Test \
85         test/hs/Test/Ganeti \
86         test/hs/Test/Ganeti/Storage \
87         test/hs/Test/Ganeti/Storage/Diskstats \
88         test/hs/Test/Ganeti/Storage/Drbd \
89         test/hs/Test/Ganeti/Storage/Lvm \
90         test/hs/Test/Ganeti/Confd \
91         test/hs/Test/Ganeti/HTools \
92         test/hs/Test/Ganeti/HTools/Backend \
93         test/hs/Test/Ganeti/Hypervisor \
94         test/hs/Test/Ganeti/Hypervisor/Xen \
95         test/hs/Test/Ganeti/Query
96
97 # Haskell directories without the roots (src, test/hs)
98 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
99
100 DIRS = \
101         $(HS_DIRS) \
102         autotools \
103         daemons \
104         devel \
105         devel/data \
106         doc \
107         doc/css \
108         doc/examples \
109         doc/examples/gnt-debug \
110         doc/examples/hooks \
111         test/data/htools \
112         test/data/htools/rapi \
113         test/hs/shelltests \
114         test/autotools \
115         lib \
116         lib/build \
117         lib/client \
118         lib/cmdlib \
119         lib/confd \
120         lib/http \
121         lib/hypervisor \
122         lib/impexpd \
123         lib/masterd \
124         lib/rapi \
125         lib/server \
126         lib/storage \
127         lib/tools \
128         lib/utils \
129         lib/watcher \
130         man \
131         qa \
132         test \
133         test/data \
134         test/data/bdev-rbd \
135         test/data/ovfdata \
136         test/data/ovfdata/other \
137         test/py \
138         tools
139
140 ALL_APIDOC_HS_DIRS = \
141         $(APIDOC_HS_DIR) \
142         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
143
144 BUILDTIME_DIR_AUTOCREATE = \
145         scripts \
146         $(APIDOC_DIR) \
147         $(ALL_APIDOC_HS_DIRS) \
148         $(APIDOC_PY_DIR) \
149         $(COVERAGE_DIR) \
150         $(COVERAGE_HS_DIR) \
151         $(COVERAGE_PY_DIR) \
152         .hpc
153
154 BUILDTIME_DIRS = \
155         $(BUILDTIME_DIR_AUTOCREATE) \
156         doc/html \
157         doc/man-html
158
159 DIRCHECK_EXCLUDE = \
160         $(BUILDTIME_DIRS) \
161         ganeti-[0-9]*.[0-9]*.[0-9]* \
162         doc/html/_* \
163         doc/man-html/_* \
164         autom4te.cache
165
166 # some helper vars
167 COVERAGE_DIR = doc/coverage
168 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
169 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
170 APIDOC_DIR = doc/api
171 APIDOC_PY_DIR = $(APIDOC_DIR)/py
172 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
173
174 MAINTAINERCLEANFILES = \
175         $(maninput) \
176         doc/install-quick.rst \
177         doc/news.rst \
178         doc/upgrade.rst \
179         vcs-version
180
181 maintainer-clean-local:
182         rm -rf $(BUILDTIME_DIRS)
183
184 CLEANFILES = \
185         $(addsuffix /*.py[co],$(DIRS)) \
186         $(addsuffix /*.hi,$(HS_DIRS)) \
187         $(addsuffix /*.o,$(HS_DIRS)) \
188         $(PYTHON_BOOTSTRAP) \
189         epydoc.conf \
190         $(REPLACE_VARS_SED) \
191         $(SHELL_ENV_INIT) \
192         daemons/daemon-util \
193         daemons/ganeti-cleaner \
194         devel/squeeze-amd64.tar.gz \
195         devel/squeeze-amd64.conf \
196         $(mandocrst) \
197         doc/manpages-enabled.rst \
198         $(BUILT_EXAMPLES) \
199         doc/examples/bash_completion \
200         doc/examples/bash_completion-debug \
201         lib/_generated_rpc.py \
202         $(man_MANS) \
203         $(manhtml) \
204         tools/kvm-ifup \
205         tools/vif-ganeti \
206         tools/net-common \
207         tools/users-setup \
208         tools/vcluster-setup \
209         stamp-directories \
210         stamp-srclinks \
211         $(nodist_pkgpython_PYTHON) \
212         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
213         $(HS_BUILT_TEST_HELPERS) \
214         src/ganeti-confd \
215         src/ganeti-luxid \
216         src/ganeti-mond \
217         .hpc/*.mix src/*.tix test/hs/*.tix \
218         doc/hs-lint.html
219
220 GENERATED_FILES = \
221         $(built_base_sources) \
222         $(BUILT_PYTHON_SOURCES) \
223         $(PYTHON_BOOTSTRAP)
224
225 HS_GENERATED_FILES =
226 if WANT_HTOOLS
227 HS_GENERATED_FILES += $(HS_PROGS)
228 if ENABLE_CONFD
229 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
230 endif
231
232 if ENABLE_MOND
233 HS_GENERATED_FILES += src/ganeti-mond
234 endif
235 endif
236
237 built_base_sources = \
238         stamp-directories \
239         stamp-srclinks
240
241 built_python_base_sources = \
242         lib/_autoconf.py \
243         lib/_vcsversion.py
244
245 BUILT_PYTHON_SOURCES = \
246         $(built_python_base_sources) \
247         lib/_generated_rpc.py
248
249 # Generating the RPC wrappers depends on many things, so make sure
250 # it's built at the end of the built sources
251 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
252
253 # these are all built from the underlying %.in sources
254 BUILT_EXAMPLES = \
255         doc/examples/ganeti-kvm-poweroff.initd \
256         doc/examples/ganeti.cron \
257         doc/examples/ganeti.initd \
258         doc/examples/ganeti.logrotate \
259         doc/examples/ganeti-master-role.ocf \
260         doc/examples/ganeti-node-role.ocf \
261         doc/examples/gnt-config-backup \
262         doc/examples/hooks/ipsec
263
264 nodist_pkgpython_PYTHON = \
265         $(BUILT_PYTHON_SOURCES)
266
267 noinst_PYTHON = \
268         lib/build/__init__.py \
269         lib/build/shell_example_lexer.py \
270         lib/build/sphinx_ext.py
271
272 pkgpython_PYTHON = \
273         lib/__init__.py \
274         lib/asyncnotifier.py \
275         lib/backend.py \
276         lib/bootstrap.py \
277         lib/cli.py \
278         lib/compat.py \
279         lib/config.py \
280         lib/constants.py \
281         lib/daemon.py \
282         lib/errors.py \
283         lib/hooksmaster.py \
284         lib/ht.py \
285         lib/jqueue.py \
286         lib/jstore.py \
287         lib/locking.py \
288         lib/luxi.py \
289         lib/mcpu.py \
290         lib/netutils.py \
291         lib/objects.py \
292         lib/opcodes.py \
293         lib/outils.py \
294         lib/ovf.py \
295         lib/pathutils.py \
296         lib/qlang.py \
297         lib/query.py \
298         lib/rpc.py \
299         lib/rpc_defs.py \
300         lib/runtime.py \
301         lib/serializer.py \
302         lib/ssconf.py \
303         lib/ssh.py \
304         lib/uidpool.py \
305         lib/vcluster.py \
306         lib/network.py \
307         lib/workerpool.py
308
309 client_PYTHON = \
310         lib/client/__init__.py \
311         lib/client/gnt_backup.py \
312         lib/client/gnt_cluster.py \
313         lib/client/gnt_debug.py \
314         lib/client/gnt_group.py \
315         lib/client/gnt_instance.py \
316         lib/client/gnt_job.py \
317         lib/client/gnt_node.py \
318         lib/client/gnt_network.py \
319         lib/client/gnt_os.py \
320         lib/client/gnt_storage.py
321
322 cmdlib_PYTHON = \
323         lib/cmdlib/__init__.py \
324         lib/cmdlib/backup.py \
325         lib/cmdlib/base.py \
326         lib/cmdlib/cluster.py \
327         lib/cmdlib/common.py \
328         lib/cmdlib/group.py \
329         lib/cmdlib/instance.py \
330         lib/cmdlib/instance_migration.py \
331         lib/cmdlib/instance_operation.py \
332         lib/cmdlib/instance_query.py \
333         lib/cmdlib/instance_storage.py \
334         lib/cmdlib/instance_utils.py \
335         lib/cmdlib/misc.py \
336         lib/cmdlib/network.py \
337         lib/cmdlib/node.py \
338         lib/cmdlib/operating_system.py \
339         lib/cmdlib/query.py \
340         lib/cmdlib/tags.py \
341         lib/cmdlib/test.py
342
343 hypervisor_PYTHON = \
344         lib/hypervisor/__init__.py \
345         lib/hypervisor/hv_base.py \
346         lib/hypervisor/hv_chroot.py \
347         lib/hypervisor/hv_fake.py \
348         lib/hypervisor/hv_kvm.py \
349         lib/hypervisor/hv_lxc.py \
350         lib/hypervisor/hv_xen.py
351
352 storage_PYTHON = \
353         lib/storage/__init__.py \
354         lib/storage/bdev.py \
355         lib/storage/base.py \
356         lib/storage/container.py \
357         lib/storage/drbd.py \
358         lib/storage/drbd_info.py \
359         lib/storage/drbd_cmdgen.py \
360         lib/storage/filestorage.py
361
362 rapi_PYTHON = \
363         lib/rapi/__init__.py \
364         lib/rapi/baserlib.py \
365         lib/rapi/client.py \
366         lib/rapi/client_utils.py \
367         lib/rapi/connector.py \
368         lib/rapi/rlib2.py \
369         lib/rapi/testutils.py
370
371 http_PYTHON = \
372         lib/http/__init__.py \
373         lib/http/auth.py \
374         lib/http/client.py \
375         lib/http/server.py
376
377 confd_PYTHON = \
378         lib/confd/__init__.py \
379         lib/confd/client.py
380
381 masterd_PYTHON = \
382         lib/masterd/__init__.py \
383         lib/masterd/iallocator.py \
384         lib/masterd/instance.py
385
386 impexpd_PYTHON = \
387         lib/impexpd/__init__.py
388
389 watcher_PYTHON = \
390         lib/watcher/__init__.py \
391         lib/watcher/nodemaint.py \
392         lib/watcher/state.py
393
394 server_PYTHON = \
395         lib/server/__init__.py \
396         lib/server/masterd.py \
397         lib/server/noded.py \
398         lib/server/rapi.py
399
400 pytools_PYTHON = \
401         lib/tools/__init__.py \
402         lib/tools/burnin.py \
403         lib/tools/ensure_dirs.py \
404         lib/tools/node_cleanup.py \
405         lib/tools/node_daemon_setup.py \
406         lib/tools/prepare_node_join.py
407
408 utils_PYTHON = \
409         lib/utils/__init__.py \
410         lib/utils/algo.py \
411         lib/utils/filelock.py \
412         lib/utils/hash.py \
413         lib/utils/io.py \
414         lib/utils/log.py \
415         lib/utils/lvm.py \
416         lib/utils/mlock.py \
417         lib/utils/nodesetup.py \
418         lib/utils/process.py \
419         lib/utils/retry.py \
420         lib/utils/storage.py \
421         lib/utils/text.py \
422         lib/utils/wrapper.py \
423         lib/utils/x509.py
424
425 docinput = \
426         doc/conf.py \
427         doc/css/style.css \
428         doc/admin.rst \
429         doc/cluster-merge.rst \
430         doc/design-2.0.rst \
431         doc/design-2.1.rst \
432         doc/design-2.2.rst \
433         doc/design-2.3.rst \
434         doc/design-2.4.rst \
435         doc/design-2.5.rst \
436         doc/design-2.6.rst \
437         doc/design-2.7.rst \
438         doc/design-2.8.rst \
439         doc/design-autorepair.rst \
440         doc/design-bulk-create.rst \
441         doc/design-chained-jobs.rst \
442         doc/design-cpu-pinning.rst \
443         doc/design-device-uuid-name.rst \
444         doc/design-draft.rst \
445         doc/design-htools-2.3.rst \
446         doc/design-http-server.rst \
447         doc/design-impexp2.rst \
448         doc/design-internal-shutdown.rst \
449         doc/design-lu-generated-jobs.rst \
450         doc/design-linuxha.rst \
451         doc/design-multi-reloc.rst \
452         doc/design-network.rst \
453         doc/design-node-add.rst \
454         doc/design-oob.rst \
455         doc/design-ovf-support.rst \
456         doc/design-opportunistic-locking.rst \
457         doc/design-partitioned.rst \
458         doc/design-query-splitting.rst \
459         doc/design-query2.rst \
460         doc/design-reason-trail.rst \
461         doc/design-resource-model.rst \
462         doc/design-restricted-commands.rst \
463         doc/design-shared-storage.rst \
464         doc/design-monitoring-agent.rst \
465         doc/design-virtual-clusters.rst \
466         doc/design-x509-ca.rst \
467         doc/design-hroller.rst \
468         doc/design-storagetypes.rst \
469         doc/devnotes.rst \
470         doc/glossary.rst \
471         doc/hooks.rst \
472         doc/iallocator.rst \
473         doc/index.rst \
474         doc/install-quick.rst \
475         doc/install.rst \
476         doc/locking.rst \
477         doc/manpages-disabled.rst \
478         doc/monitoring-query-format.rst \
479         doc/move-instance.rst \
480         doc/news.rst \
481         doc/ovfconverter.rst \
482         doc/rapi.rst \
483         doc/security.rst \
484         doc/upgrade.rst \
485         doc/virtual-cluster.rst \
486         doc/walkthrough.rst
487
488 # Generates file names such as "doc/man-gnt-instance.rst"
489 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
490
491 # Haskell programs to be installed in $PREFIX/bin
492 HS_BIN_PROGS=src/htools
493
494 # Haskell programs to be installed in the MYEXECLIB dir
495 if ENABLE_MOND
496 HS_MYEXECLIB_PROGS=src/mon-collector
497 else
498 HS_MYEXECLIB_PROGS=
499 endif
500
501 # Haskell programs to be compiled by "make really-all"
502 HS_COMPILE_PROGS= \
503         src/ganeti-mond \
504         src/hconfd \
505         src/hluxid \
506         src/rpc-test
507
508 # All Haskell non-test programs to be compiled but not automatically installed
509 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
510
511 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
512 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
513
514 HS_ALL_PROGS = \
515         $(HS_PROGS) \
516         test/hs/hpc-htools \
517         test/hs/hpc-mon-collector \
518         test/hs/htest \
519         $(HS_COMPILE_PROGS)
520
521 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
522 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
523
524 HFLAGS = \
525         -O -Wall -Werror -isrc \
526         -fwarn-monomorphism-restriction \
527         -fwarn-tabs \
528         $(GHC_BYVERSION_FLAGS)
529
530 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
531 HEXTRA =
532 # internal extra flags (used for test/hs/htest mainly)
533 HEXTRA_INT =
534 # exclude options for coverage reports
535 HPCEXCL = --exclude Main \
536         --exclude Ganeti.Constants \
537         --exclude Ganeti.HTools.QC \
538         --exclude Ganeti.THH \
539         --exclude Ganeti.Version \
540         --exclude Test.Ganeti.Attoparsec \
541         --exclude Test.Ganeti.TestCommon \
542         --exclude Test.Ganeti.TestHTools \
543         --exclude Test.Ganeti.TestHelper \
544         --exclude Test.Ganeti.TestImports \
545         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
546
547 HS_LIB_SRCS = \
548         src/Ganeti/BasicTypes.hs \
549         src/Ganeti/Common.hs \
550         src/Ganeti/Compat.hs \
551         src/Ganeti/Confd/Client.hs \
552         src/Ganeti/Confd/ClientFunctions.hs \
553         src/Ganeti/Confd/Server.hs \
554         src/Ganeti/Confd/Types.hs \
555         src/Ganeti/Confd/Utils.hs \
556         src/Ganeti/Config.hs \
557         src/Ganeti/ConfigReader.hs \
558         src/Ganeti/Curl/Multi.hs \
559         src/Ganeti/Daemon.hs \
560         src/Ganeti/DataCollectors/CLI.hs \
561         src/Ganeti/DataCollectors/Diskstats.hs \
562         src/Ganeti/DataCollectors/Drbd.hs \
563         src/Ganeti/DataCollectors/InstStatus.hs \
564         src/Ganeti/DataCollectors/InstStatusTypes.hs \
565         src/Ganeti/DataCollectors/Lv.hs \
566         src/Ganeti/DataCollectors/Program.hs \
567         src/Ganeti/DataCollectors/Types.hs \
568         src/Ganeti/Errors.hs \
569         src/Ganeti/HTools/Backend/IAlloc.hs \
570         src/Ganeti/HTools/Backend/Luxi.hs \
571         src/Ganeti/HTools/Backend/Rapi.hs \
572         src/Ganeti/HTools/Backend/Simu.hs \
573         src/Ganeti/HTools/Backend/Text.hs \
574         src/Ganeti/HTools/CLI.hs \
575         src/Ganeti/HTools/Cluster.hs \
576         src/Ganeti/HTools/Container.hs \
577         src/Ganeti/HTools/ExtLoader.hs \
578         src/Ganeti/HTools/Graph.hs \
579         src/Ganeti/HTools/Group.hs \
580         src/Ganeti/HTools/Instance.hs \
581         src/Ganeti/HTools/Loader.hs \
582         src/Ganeti/HTools/Nic.hs \
583         src/Ganeti/HTools/Node.hs \
584         src/Ganeti/HTools/PeerMap.hs \
585         src/Ganeti/HTools/Program/Hail.hs \
586         src/Ganeti/HTools/Program/Harep.hs \
587         src/Ganeti/HTools/Program/Hbal.hs \
588         src/Ganeti/HTools/Program/Hcheck.hs \
589         src/Ganeti/HTools/Program/Hinfo.hs \
590         src/Ganeti/HTools/Program/Hscan.hs \
591         src/Ganeti/HTools/Program/Hspace.hs \
592         src/Ganeti/HTools/Program/Hroller.hs \
593         src/Ganeti/HTools/Program/Main.hs \
594         src/Ganeti/HTools/Types.hs \
595         src/Ganeti/Hypervisor/Xen.hs \
596         src/Ganeti/Hypervisor/Xen/XmParser.hs \
597         src/Ganeti/Hypervisor/Xen/Types.hs \
598         src/Ganeti/Hash.hs \
599         src/Ganeti/JQueue.hs \
600         src/Ganeti/JSON.hs \
601         src/Ganeti/Jobs.hs \
602         src/Ganeti/Logging.hs \
603         src/Ganeti/Luxi.hs \
604         src/Ganeti/Monitoring/Server.hs \
605         src/Ganeti/Network.hs \
606         src/Ganeti/Objects.hs \
607         src/Ganeti/OpCodes.hs \
608         src/Ganeti/OpParams.hs \
609         src/Ganeti/Path.hs \
610         src/Ganeti/Query/Cluster.hs \
611         src/Ganeti/Query/Common.hs \
612         src/Ganeti/Query/Export.hs \
613         src/Ganeti/Query/Filter.hs \
614         src/Ganeti/Query/Group.hs \
615         src/Ganeti/Query/Job.hs \
616         src/Ganeti/Query/Language.hs \
617         src/Ganeti/Query/Network.hs \
618         src/Ganeti/Query/Node.hs \
619         src/Ganeti/Query/Query.hs \
620         src/Ganeti/Query/Server.hs \
621         src/Ganeti/Query/Types.hs \
622         src/Ganeti/Rpc.hs \
623         src/Ganeti/Runtime.hs \
624         src/Ganeti/Ssconf.hs \
625         src/Ganeti/Storage/Diskstats/Parser.hs \
626         src/Ganeti/Storage/Diskstats/Types.hs \
627         src/Ganeti/Storage/Drbd/Parser.hs \
628         src/Ganeti/Storage/Drbd/Types.hs \
629         src/Ganeti/Storage/Lvm/LVParser.hs \
630         src/Ganeti/Storage/Lvm/Types.hs \
631         src/Ganeti/Storage/Utils.hs \
632         src/Ganeti/THH.hs \
633         src/Ganeti/Types.hs \
634         src/Ganeti/Utils.hs
635
636 HS_TEST_SRCS = \
637         test/hs/Test/Ganeti/Attoparsec.hs \
638         test/hs/Test/Ganeti/BasicTypes.hs \
639         test/hs/Test/Ganeti/Common.hs \
640         test/hs/Test/Ganeti/Confd/Types.hs \
641         test/hs/Test/Ganeti/Confd/Utils.hs \
642         test/hs/Test/Ganeti/Daemon.hs \
643         test/hs/Test/Ganeti/Errors.hs \
644         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
645         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
646         test/hs/Test/Ganeti/HTools/CLI.hs \
647         test/hs/Test/Ganeti/HTools/Cluster.hs \
648         test/hs/Test/Ganeti/HTools/Container.hs \
649         test/hs/Test/Ganeti/HTools/Graph.hs \
650         test/hs/Test/Ganeti/HTools/Instance.hs \
651         test/hs/Test/Ganeti/HTools/Loader.hs \
652         test/hs/Test/Ganeti/HTools/Node.hs \
653         test/hs/Test/Ganeti/HTools/PeerMap.hs \
654         test/hs/Test/Ganeti/HTools/Types.hs \
655         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
656         test/hs/Test/Ganeti/JSON.hs \
657         test/hs/Test/Ganeti/Jobs.hs \
658         test/hs/Test/Ganeti/JQueue.hs \
659         test/hs/Test/Ganeti/Luxi.hs \
660         test/hs/Test/Ganeti/Network.hs \
661         test/hs/Test/Ganeti/Objects.hs \
662         test/hs/Test/Ganeti/OpCodes.hs \
663         test/hs/Test/Ganeti/Query/Filter.hs \
664         test/hs/Test/Ganeti/Query/Language.hs \
665         test/hs/Test/Ganeti/Query/Network.hs \
666         test/hs/Test/Ganeti/Query/Query.hs \
667         test/hs/Test/Ganeti/Rpc.hs \
668         test/hs/Test/Ganeti/Runtime.hs \
669         test/hs/Test/Ganeti/Ssconf.hs \
670         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
671         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
672         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
673         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
674         test/hs/Test/Ganeti/THH.hs \
675         test/hs/Test/Ganeti/TestCommon.hs \
676         test/hs/Test/Ganeti/TestHTools.hs \
677         test/hs/Test/Ganeti/TestHelper.hs \
678         test/hs/Test/Ganeti/Types.hs \
679         test/hs/Test/Ganeti/Utils.hs
680
681 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
682
683 HS_BUILT_SRCS = \
684         test/hs/Test/Ganeti/TestImports.hs \
685         src/Ganeti/Constants.hs \
686         src/Ganeti/Curl/Internal.hs \
687         src/Ganeti/Version.hs
688 HS_BUILT_SRCS_IN = \
689         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
690         src/Ganeti/Curl/Internal.hsc
691
692 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
693
694 $(RUN_IN_TEMPDIR): | stamp-directories
695
696 doc/html/index.html: ENABLE_MANPAGES =
697 doc/man-html/index.html: ENABLE_MANPAGES = 1
698 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
699
700 # Note: we use here an order-only prerequisite, as the contents of
701 # _autoconf.py are not actually influencing the html build output: it
702 # has to exist in order for the sphinx module to be loaded
703 # successfully, but we certainly don't want the docs to be rebuilt if
704 # it changes
705 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
706         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
707         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
708         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
709         | $(BUILT_PYTHON_SOURCES)
710         @test -n "$(SPHINX)" || \
711             { echo 'sphinx-build' not found during configure; exit 1; }
712 if !MANPAGES_IN_DOC
713         if test -n '$(ENABLE_MANPAGES)'; then \
714           echo 'Man pages in documentation were disabled at configure time' >&2; \
715           exit 1; \
716         fi
717 endif
718 ## Sphinx provides little control over what content should be included. Some
719 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
720 ## build two different versions of the documentation--once without man pages and
721 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
722 ## us with this, but requires running in a temporary directory. It moves the
723 ## correct files into place depending on environment variables.
724         dir=$(dir $@) && \
725         @mkdir_p@ $$dir && \
726         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
727         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
728             -d . \
729             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
730             -D release="$(PACKAGE_VERSION)" \
731             -D graphviz_dot="$(DOT)" \
732             -D enable_manpages="$(ENABLE_MANPAGES)" \
733             doc $(CURDIR)/$$dir && \
734         rm -f $$dir/.buildinfo $$dir/objects.inv
735         touch $@
736
737 doc/html: doc/html/index.html
738
739 doc/man-html: doc/man-html/index.html
740
741 doc/install-quick.rst: INSTALL
742 doc/news.rst: NEWS
743 doc/upgrade.rst: UPGRADE
744
745 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
746         set -e; \
747         { echo '.. This file is automatically updated at build time from $<.'; \
748           echo '.. Do not edit.'; \
749           echo; \
750           cat $<; \
751         } > $@
752
753 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
754         { echo '.. This file is automatically generated, do not edit!'; \
755           echo ''; \
756           echo 'Man pages'; \
757           echo '========='; \
758           echo; \
759           echo '.. toctree::'; \
760           echo '   :maxdepth: 1'; \
761           echo; \
762           for i in $(notdir $(mandocrst)); do \
763             echo "   $$i"; \
764           done | LC_ALL=C sort; \
765         } > $@
766
767 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
768 if MANPAGES_IN_DOC
769         { echo '.. This file is automatically updated at build time from $<.'; \
770           echo '.. Do not edit.'; \
771           echo; \
772           echo "$*"; \
773           echo '=========================================='; \
774           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
775         } > $@
776 else
777         echo 'Man pages in documentation were disabled at configure time' >&2; \
778         exit 1;
779 endif
780
781 # Things to build but not to install (add it to EXTRA_DIST if it should be
782 # distributed)
783 noinst_DATA = \
784         $(BUILT_EXAMPLES) \
785         doc/examples/bash_completion \
786         doc/examples/bash_completion-debug \
787         $(manhtml)
788
789 if HAS_SPHINX
790 if MANPAGES_IN_DOC
791 noinst_DATA += doc/man-html
792 else
793 noinst_DATA += doc/html
794 endif
795 endif
796
797 gnt_scripts = \
798         scripts/gnt-backup \
799         scripts/gnt-cluster \
800         scripts/gnt-debug \
801         scripts/gnt-group \
802         scripts/gnt-instance \
803         scripts/gnt-job \
804         scripts/gnt-network \
805         scripts/gnt-node \
806         scripts/gnt-os \
807         scripts/gnt-storage
808
809 PYTHON_BOOTSTRAP_SBIN = \
810         daemons/ganeti-masterd \
811         daemons/ganeti-noded \
812         daemons/ganeti-rapi \
813         daemons/ganeti-watcher \
814         $(gnt_scripts)
815
816 PYTHON_BOOTSTRAP = \
817         $(PYTHON_BOOTSTRAP_SBIN) \
818         tools/burnin \
819         tools/ensure-dirs \
820         tools/node-cleanup \
821         tools/node-daemon-setup \
822         tools/prepare-node-join
823
824 qa_scripts = \
825         qa/__init__.py \
826         qa/ganeti-qa.py \
827         qa/qa_cluster.py \
828         qa/qa_config.py \
829         qa/qa_daemon.py \
830         qa/qa_env.py \
831         qa/qa_error.py \
832         qa/qa_group.py \
833         qa/qa_instance.py \
834         qa/qa_instance_utils.py \
835         qa/qa_job.py \
836         qa/qa_monitoring.py \
837         qa/qa_node.py \
838         qa/qa_os.py \
839         qa/qa_rapi.py \
840         qa/qa_tags.py \
841         qa/qa_utils.py
842
843 bin_SCRIPTS =
844 if WANT_HTOOLS
845 bin_SCRIPTS += $(HS_BIN_PROGS)
846 install-exec-hook:
847         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
848 # FIXME: this is a hardcoded logic, instead of auto-resolving
849         $(LN_S) -f ../../../bin/htools \
850           $(DESTDIR)$(iallocatorsdir)/hail
851         for role in $(HS_BIN_ROLES); do \
852           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
853         done
854 endif
855
856 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
857         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
858           echo "Error: cannot run unittests without the development" \
859                " libraries (see devnotes.rst)" 1>&2; \
860           exit 1; \
861         fi
862         @rm -f $(notdir $@).tix
863         $(GHC) --make \
864           $(HFLAGS) \
865           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
866           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
867           $(HEXTRA) $(HEXTRA_INT) $@
868         @touch "$@"
869
870 # for the test/hs/htest binary, we need to enable profiling/coverage
871 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
872
873 # we compile the hpc-htools binary with the program coverage
874 test/hs/hpc-htools: HEXTRA_INT=-fhpc
875
876 # we compile the hpc-mon-collector binary with the program coverage
877 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
878
879 # test dependency
880 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
881
882 # rules for building profiling-enabled versions of the haskell
883 # programs: hs-prof does the full two-step build, whereas
884 # hs-prof-quick does only the final rebuild (hs-prof must have been
885 # run before)
886 .PHONY: hs-prof hs-prof-quick
887 hs-prof:
888         @if [ -z "$(TARGET)" ]; then \
889           echo "You need to define TARGET when running this rule" 1>&2; \
890           exit 1; \
891         fi
892         $(MAKE) $(AM_MAKEFLAGS) clean
893         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
894         rm -f $(HS_ALL_PROGS)
895         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
896
897 hs-prof-quick:
898         @if [ -z "$(TARGET)" ]; then \
899           echo "You need to define TARGET when running this rule" 1>&2; \
900           exit 1; \
901         fi
902         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
903
904 dist_sbin_SCRIPTS = \
905         tools/ganeti-listrunner
906
907 nodist_sbin_SCRIPTS = \
908         $(PYTHON_BOOTSTRAP_SBIN) \
909         daemons/ganeti-cleaner
910
911 if ENABLE_CONFD
912 src/ganeti-confd: src/hconfd
913         cp -f $< $@
914
915 src/ganeti-luxid: src/hluxid
916         cp -f $< $@
917
918 nodist_sbin_SCRIPTS += src/ganeti-confd
919 nodist_sbin_SCRIPTS += src/ganeti-luxid
920 endif
921
922 if ENABLE_MOND
923 nodist_sbin_SCRIPTS += src/ganeti-mond
924 endif
925
926 python_scripts = \
927         tools/cfgshell \
928         tools/cfgupgrade \
929         tools/cfgupgrade12 \
930         tools/cluster-merge \
931         tools/confd-client \
932         tools/fmtjson \
933         tools/lvmstrap \
934         tools/move-instance \
935         tools/ovfconverter \
936         tools/sanitize-config
937
938 dist_tools_SCRIPTS = \
939         $(python_scripts) \
940         tools/burnin \
941         tools/kvm-console-wrapper \
942         tools/master-ip-setup \
943         tools/xen-console-wrapper
944
945 nodist_tools_python_scripts = \
946         tools/node-cleanup
947
948 nodist_tools_SCRIPTS = \
949         $(nodist_tools_python_scripts) \
950         tools/users-setup \
951         tools/vcluster-setup
952
953 pkglib_python_scripts = \
954         daemons/import-export \
955         tools/check-cert-expired
956
957 nodist_pkglib_python_scripts = \
958         tools/ensure-dirs \
959         tools/node-daemon-setup \
960         tools/prepare-node-join
961
962 myexeclib_SCRIPTS = \
963         daemons/daemon-util \
964         tools/kvm-ifup \
965         tools/vif-ganeti \
966         tools/net-common \
967         $(pkglib_python_scripts) \
968         $(HS_MYEXECLIB_PROGS)
969
970 nodist_myexeclib_SCRIPTS = \
971         $(nodist_pkglib_python_scripts)
972
973 EXTRA_DIST = \
974         NEWS \
975         UPGRADE \
976         epydoc.conf.in \
977         pylintrc \
978         autotools/build-bash-completion \
979         autotools/build-rpc \
980         autotools/check-header \
981         autotools/check-imports \
982         autotools/check-man-dashes \
983         autotools/check-man-references \
984         autotools/check-man-warnings \
985         autotools/check-news \
986         autotools/check-python-code \
987         autotools/check-tar \
988         autotools/check-version \
989         autotools/convert-constants \
990         autotools/docpp \
991         autotools/gen-py-coverage \
992         autotools/sphinx-wrapper \
993         autotools/testrunner \
994         autotools/wrong-hardcoded-paths \
995         $(RUN_IN_TEMPDIR) \
996         daemons/daemon-util.in \
997         daemons/ganeti-cleaner.in \
998         $(pkglib_python_scripts) \
999         devel/upload \
1000         devel/webserver \
1001         tools/kvm-ifup.in \
1002         tools/vif-ganeti.in \
1003         tools/net-common.in \
1004         tools/users-setup.in \
1005         tools/vcluster-setup.in \
1006         $(docinput) \
1007         doc/html \
1008         $(BUILT_EXAMPLES:%=%.in) \
1009         doc/examples/ganeti.default \
1010         doc/examples/ganeti.default-debug \
1011         doc/examples/hooks/ethers \
1012         doc/examples/gnt-debug/README \
1013         doc/examples/gnt-debug/delay0.json \
1014         doc/examples/gnt-debug/delay50.json \
1015         test/py/lockperf.py \
1016         test/py/testutils.py \
1017         test/py/mocks.py \
1018         $(dist_TESTS) \
1019         $(TEST_FILES) \
1020         man/footer.rst \
1021         $(manrst) \
1022         $(maninput) \
1023         qa/qa-sample.json \
1024         $(qa_scripts) \
1025         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1026         $(HS_PROG_SRCS) \
1027         src/lint-hints.hs \
1028         test/hs/cli-tests-defs.sh \
1029         test/hs/offline-test.sh \
1030         .ghci
1031
1032 man_MANS = \
1033         man/ganeti-cleaner.8 \
1034         man/ganeti-confd.8 \
1035         man/ganeti-luxid.8 \
1036         man/ganeti-listrunner.8 \
1037         man/ganeti-masterd.8 \
1038         man/ganeti-mond.8 \
1039         man/ganeti-noded.8 \
1040         man/ganeti-os-interface.7 \
1041         man/ganeti-extstorage-interface.7 \
1042         man/ganeti-rapi.8 \
1043         man/ganeti-watcher.8 \
1044         man/ganeti.7 \
1045         man/gnt-backup.8 \
1046         man/gnt-cluster.8 \
1047         man/gnt-debug.8 \
1048         man/gnt-group.8 \
1049         man/gnt-network.8 \
1050         man/gnt-instance.8 \
1051         man/gnt-job.8 \
1052         man/gnt-node.8 \
1053         man/gnt-os.8 \
1054         man/gnt-storage.8 \
1055         man/hail.1 \
1056         man/harep.1 \
1057         man/hbal.1 \
1058         man/hcheck.1 \
1059         man/hinfo.1 \
1060         man/hscan.1 \
1061         man/hspace.1 \
1062         man/hroller.1 \
1063         man/htools.1 \
1064         man/mon-collector.7
1065
1066 # Remove extensions from all filenames in man_MANS
1067 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1068
1069 manrst = $(patsubst %,%.rst,$(mannoext))
1070 manhtml = $(patsubst %.rst,%.html,$(manrst))
1071 mangen = $(patsubst %.rst,%.gen,$(manrst))
1072 maninput = \
1073         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1074         $(patsubst %.html,%.html.in,$(manhtml)) \
1075         $(mangen)
1076
1077 TEST_FILES = \
1078         test/autotools/autotools-check-news.test \
1079         test/data/htools/clean-nonzero-score.data \
1080         test/data/htools/common-suffix.data \
1081         test/data/htools/empty-cluster.data \
1082         test/data/htools/hail-alloc-drbd.json \
1083         test/data/htools/hail-alloc-invalid-network.json \
1084         test/data/htools/hail-alloc-invalid-twodisks.json \
1085         test/data/htools/hail-alloc-restricted-network.json \
1086         test/data/htools/hail-alloc-spindles.json \
1087         test/data/htools/hail-alloc-twodisks.json \
1088         test/data/htools/hail-change-group.json \
1089         test/data/htools/hail-invalid-reloc.json \
1090         test/data/htools/hail-node-evac.json \
1091         test/data/htools/hail-reloc-drbd.json \
1092         test/data/htools/hbal-excl-tags.data \
1093         test/data/htools/hbal-split-insts.data \
1094         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1095         test/data/htools/hspace-tiered-dualspec.data \
1096         test/data/htools/hspace-tiered-exclusive.data \
1097         test/data/htools/hspace-tiered-ipolicy.data \
1098         test/data/htools/hspace-tiered-mixed.data \
1099         test/data/htools/hspace-tiered-resourcetypes.data \
1100         test/data/htools/hspace-tiered-vcpu.data \
1101         test/data/htools/hspace-tiered.data \
1102         test/data/htools/invalid-node.data \
1103         test/data/htools/missing-resources.data \
1104         test/data/htools/multiple-master.data \
1105         test/data/htools/multiple-tags.data \
1106         test/data/htools/n1-failure.data \
1107         test/data/htools/rapi/groups.json \
1108         test/data/htools/rapi/info.json \
1109         test/data/htools/rapi/instances.json \
1110         test/data/htools/rapi/nodes.json \
1111         test/data/htools/hroller-full.data \
1112         test/data/htools/hroller-nodegroups.data \
1113         test/data/htools/hroller-nonredundant.data \
1114         test/data/htools/hroller-online.data \
1115         test/data/htools/unique-reboot-order.data \
1116         test/hs/shelltests/htools-balancing.test \
1117         test/hs/shelltests/htools-basic.test \
1118         test/hs/shelltests/htools-dynutil.test \
1119         test/hs/shelltests/htools-excl.test \
1120         test/hs/shelltests/htools-hail.test \
1121         test/hs/shelltests/htools-hroller.test \
1122         test/hs/shelltests/htools-hspace.test \
1123         test/hs/shelltests/htools-invalid.test \
1124         test/hs/shelltests/htools-multi-group.test \
1125         test/hs/shelltests/htools-no-backend.test \
1126         test/hs/shelltests/htools-rapi.test \
1127         test/hs/shelltests/htools-single-group.test \
1128         test/hs/shelltests/htools-text-backend.test \
1129         test/hs/shelltests/htools-mon-collector.test \
1130         test/data/bdev-drbd-8.0.txt \
1131         test/data/bdev-drbd-8.3.txt \
1132         test/data/bdev-drbd-8.4.txt \
1133         test/data/bdev-drbd-8.4-no-disk-params.txt \
1134         test/data/bdev-drbd-disk.txt \
1135         test/data/bdev-drbd-net-ip4.txt \
1136         test/data/bdev-drbd-net-ip6.txt \
1137         test/data/bdev-rbd/json_output_empty.txt \
1138         test/data/bdev-rbd/json_output_extra_matches.txt \
1139         test/data/bdev-rbd/json_output_no_matches.txt \
1140         test/data/bdev-rbd/json_output_ok.txt \
1141         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1142         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1143         test/data/bdev-rbd/plain_output_new_ok.txt \
1144         test/data/bdev-rbd/plain_output_old_empty.txt \
1145         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1146         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1147         test/data/bdev-rbd/plain_output_old_ok.txt \
1148         test/data/bdev-rbd/output_invalid.txt \
1149         test/data/cert1.pem \
1150         test/data/cert2.pem \
1151         test/data/cluster_config_2.7.json \
1152         test/data/cluster_config_2.8.json \
1153         test/data/instance-minor-pairing.txt \
1154         test/data/instance-prim-sec.txt \
1155         test/data/ip-addr-show-dummy0.txt \
1156         test/data/ip-addr-show-lo-ipv4.txt \
1157         test/data/ip-addr-show-lo-ipv6.txt \
1158         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1159         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1160         test/data/ip-addr-show-lo-oneline.txt \
1161         test/data/ip-addr-show-lo.txt \
1162         test/data/kvm_0.12.5_help.txt \
1163         test/data/kvm_0.15.90_help.txt \
1164         test/data/kvm_0.9.1_help.txt \
1165         test/data/kvm_0.9.1_help_boot_test.txt \
1166         test/data/kvm_1.0_help.txt \
1167         test/data/kvm_1.1.2_help.txt \
1168         test/data/lvs_lv.txt \
1169         test/data/NEWS_OK.txt \
1170         test/data/NEWS_previous_unreleased.txt \
1171         test/data/ovfdata/compr_disk.vmdk.gz \
1172         test/data/ovfdata/config.ini \
1173         test/data/ovfdata/corrupted_resources.ovf \
1174         test/data/ovfdata/empty.ini \
1175         test/data/ovfdata/empty.ovf \
1176         test/data/ovfdata/ganeti.mf \
1177         test/data/ovfdata/ganeti.ovf \
1178         test/data/ovfdata/gzip_disk.ovf \
1179         test/data/ovfdata/new_disk.vmdk \
1180         test/data/ovfdata/no_disk.ini \
1181         test/data/ovfdata/no_disk_in_ref.ovf \
1182         test/data/ovfdata/no_os.ini \
1183         test/data/ovfdata/no_ovf.ova \
1184         test/data/ovfdata/other/rawdisk.raw \
1185         test/data/ovfdata/ova.ova \
1186         test/data/ovfdata/rawdisk.raw \
1187         test/data/ovfdata/second_disk.vmdk \
1188         test/data/ovfdata/unsafe_path.ini \
1189         test/data/ovfdata/virtualbox.ovf \
1190         test/data/ovfdata/wrong_config.ini \
1191         test/data/ovfdata/wrong_extension.ovd \
1192         test/data/ovfdata/wrong_manifest.mf \
1193         test/data/ovfdata/wrong_manifest.ovf \
1194         test/data/ovfdata/wrong_ova.ova \
1195         test/data/ovfdata/wrong_xml.ovf \
1196         test/data/proc_diskstats.txt \
1197         test/data/proc_drbd8.txt \
1198         test/data/proc_drbd80-emptyline.txt \
1199         test/data/proc_drbd80-emptyversion.txt \
1200         test/data/proc_drbd83.txt \
1201         test/data/proc_drbd83_sync.txt \
1202         test/data/proc_drbd83_sync_want.txt \
1203         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1204         test/data/proc_drbd84.txt \
1205         test/data/proc_drbd84_sync.txt \
1206         test/data/qa-minimal-nodes-instances-only.json \
1207         test/data/sys_drbd_usermode_helper.txt \
1208         test/data/vgreduce-removemissing-2.02.02.txt \
1209         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1210         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1211         test/data/vgs-missing-pvs-2.02.02.txt \
1212         test/data/vgs-missing-pvs-2.02.66.txt \
1213         test/data/xen-xm-info-4.0.1.txt \
1214         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1215         test/data/xen-xm-list-4.0.1-four-instances.txt \
1216         test/data/xen-xm-list-long-4.0.1.txt \
1217         test/data/xen-xm-uptime-4.0.1.txt \
1218         test/py/ganeti-cli.test \
1219         test/py/gnt-cli.test \
1220         test/py/import-export_unittest-helper
1221
1222
1223 python_tests = \
1224         doc/examples/rapi_testutils.py \
1225         test/py/cfgupgrade_unittest.py \
1226         test/py/docs_unittest.py \
1227         test/py/ganeti.asyncnotifier_unittest.py \
1228         test/py/ganeti.backend_unittest-runasroot.py \
1229         test/py/ganeti.backend_unittest.py \
1230         test/py/ganeti.bootstrap_unittest.py \
1231         test/py/ganeti.cli_unittest.py \
1232         test/py/ganeti.client.gnt_cluster_unittest.py \
1233         test/py/ganeti.client.gnt_instance_unittest.py \
1234         test/py/ganeti.client.gnt_job_unittest.py \
1235         test/py/ganeti.cmdlib_unittest.py \
1236         test/py/ganeti.cmdlib.cluster_unittest.py \
1237         test/py/ganeti.cmdlib.instance_storage_unittest.py \
1238         test/py/ganeti.compat_unittest.py \
1239         test/py/ganeti.confd.client_unittest.py \
1240         test/py/ganeti.config_unittest.py \
1241         test/py/ganeti.constants_unittest.py \
1242         test/py/ganeti.daemon_unittest.py \
1243         test/py/ganeti.errors_unittest.py \
1244         test/py/ganeti.hooks_unittest.py \
1245         test/py/ganeti.ht_unittest.py \
1246         test/py/ganeti.http_unittest.py \
1247         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1248         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1249         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1250         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1251         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1252         test/py/ganeti.hypervisor_unittest.py \
1253         test/py/ganeti.impexpd_unittest.py \
1254         test/py/ganeti.jqueue_unittest.py \
1255         test/py/ganeti.jstore_unittest.py \
1256         test/py/ganeti.locking_unittest.py \
1257         test/py/ganeti.luxi_unittest.py \
1258         test/py/ganeti.masterd.iallocator_unittest.py \
1259         test/py/ganeti.masterd.instance_unittest.py \
1260         test/py/ganeti.mcpu_unittest.py \
1261         test/py/ganeti.netutils_unittest.py \
1262         test/py/ganeti.objects_unittest.py \
1263         test/py/ganeti.opcodes_unittest.py \
1264         test/py/ganeti.outils_unittest.py \
1265         test/py/ganeti.ovf_unittest.py \
1266         test/py/ganeti.qlang_unittest.py \
1267         test/py/ganeti.query_unittest.py \
1268         test/py/ganeti.rapi.baserlib_unittest.py \
1269         test/py/ganeti.rapi.client_unittest.py \
1270         test/py/ganeti.rapi.resources_unittest.py \
1271         test/py/ganeti.rapi.rlib2_unittest.py \
1272         test/py/ganeti.rapi.testutils_unittest.py \
1273         test/py/ganeti.rpc_unittest.py \
1274         test/py/ganeti.runtime_unittest.py \
1275         test/py/ganeti.serializer_unittest.py \
1276         test/py/ganeti.server.rapi_unittest.py \
1277         test/py/ganeti.ssconf_unittest.py \
1278         test/py/ganeti.ssh_unittest.py \
1279         test/py/ganeti.storage.bdev_unittest.py \
1280         test/py/ganeti.storage.container_unittest.py \
1281         test/py/ganeti.storage.drbd_unittest.py \
1282         test/py/ganeti.storage.filestorage_unittest.py \
1283         test/py/ganeti.tools.burnin_unittest.py \
1284         test/py/ganeti.tools.ensure_dirs_unittest.py \
1285         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1286         test/py/ganeti.tools.prepare_node_join_unittest.py \
1287         test/py/ganeti.uidpool_unittest.py \
1288         test/py/ganeti.utils.algo_unittest.py \
1289         test/py/ganeti.utils.filelock_unittest.py \
1290         test/py/ganeti.utils.hash_unittest.py \
1291         test/py/ganeti.utils.io_unittest-runasroot.py \
1292         test/py/ganeti.utils.io_unittest.py \
1293         test/py/ganeti.utils.log_unittest.py \
1294         test/py/ganeti.utils.lvm_unittest.py \
1295         test/py/ganeti.utils.mlock_unittest.py \
1296         test/py/ganeti.utils.nodesetup_unittest.py \
1297         test/py/ganeti.utils.process_unittest.py \
1298         test/py/ganeti.utils.retry_unittest.py \
1299         test/py/ganeti.utils.storage_unittest.py \
1300         test/py/ganeti.utils.text_unittest.py \
1301         test/py/ganeti.utils.wrapper_unittest.py \
1302         test/py/ganeti.utils.x509_unittest.py \
1303         test/py/ganeti.utils_unittest.py \
1304         test/py/ganeti.vcluster_unittest.py \
1305         test/py/ganeti.workerpool_unittest.py \
1306         test/py/pycurl_reset_unittest.py \
1307         test/py/qa.qa_config_unittest.py \
1308         test/py/tempfile_fork_unittest.py
1309
1310 haskell_tests = test/hs/htest
1311
1312 dist_TESTS = \
1313         test/py/check-cert-expired_unittest.bash \
1314         test/py/daemon-util_unittest.bash \
1315         test/py/ganeti-cleaner_unittest.bash \
1316         test/py/import-export_unittest.bash \
1317         test/py/cli-test.bash \
1318         test/py/bash_completion.bash
1319
1320 if PY_UNIT
1321 dist_TESTS += $(python_tests)
1322 endif
1323
1324 nodist_TESTS =
1325 check_SCRIPTS =
1326
1327 if WANT_HSTESTS
1328 nodist_TESTS += $(haskell_tests)
1329 dist_TESTS += test/hs/offline-test.sh
1330 check_SCRIPTS += \
1331         test/hs/hpc-htools \
1332         test/hs/hpc-mon-collector \
1333         $(HS_BUILT_TEST_HELPERS)
1334 endif
1335
1336 TESTS = $(dist_TESTS) $(nodist_TESTS)
1337
1338 # Environment for all tests
1339 PLAIN_TESTS_ENVIRONMENT = \
1340         PYTHONPATH=. \
1341         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1342         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1343         $(RUN_IN_TEMPDIR)
1344
1345 # Environment for tests run by automake
1346 TESTS_ENVIRONMENT = \
1347         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1348
1349 all_python_code = \
1350         $(dist_sbin_SCRIPTS) \
1351         $(python_scripts) \
1352         $(pkglib_python_scripts) \
1353         $(nodist_pkglib_python_scripts) \
1354         $(nodist_tools_python_scripts) \
1355         $(pkgpython_PYTHON) \
1356         $(client_PYTHON) \
1357         $(cmdlib_PYTHON) \
1358         $(hypervisor_PYTHON) \
1359         $(storage_PYTHON) \
1360         $(rapi_PYTHON) \
1361         $(server_PYTHON) \
1362         $(pytools_PYTHON) \
1363         $(http_PYTHON) \
1364         $(confd_PYTHON) \
1365         $(masterd_PYTHON) \
1366         $(impexpd_PYTHON) \
1367         $(utils_PYTHON) \
1368         $(watcher_PYTHON) \
1369         $(noinst_PYTHON) \
1370         $(qa_scripts)
1371
1372 if PY_UNIT
1373 all_python_code += $(python_tests)
1374 endif
1375
1376 srclink_files = \
1377         man/footer.rst \
1378         test/py/check-cert-expired_unittest.bash \
1379         test/py/daemon-util_unittest.bash \
1380         test/py/ganeti-cleaner_unittest.bash \
1381         test/py/import-export_unittest.bash \
1382         test/py/cli-test.bash \
1383         test/py/bash_completion.bash \
1384         test/hs/offline-test.sh \
1385         test/hs/cli-tests-defs.sh \
1386         $(all_python_code) \
1387         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1388         $(docinput)
1389
1390 check_python_code = \
1391         $(BUILD_BASH_COMPLETION) \
1392         $(CHECK_IMPORTS) \
1393         $(CHECK_HEADER) \
1394         $(DOCPP) \
1395         $(all_python_code)
1396
1397 lint_python_code = \
1398         ganeti \
1399         ganeti/http/server.py \
1400         $(dist_sbin_SCRIPTS) \
1401         $(python_scripts) \
1402         $(pkglib_python_scripts) \
1403         $(BUILD_BASH_COMPLETION) \
1404         $(CHECK_IMPORTS) \
1405         $(CHECK_HEADER) \
1406         $(DOCPP) \
1407         $(PYTHON_BOOTSTRAP)
1408
1409 standalone_python_modules = \
1410         lib/rapi/client.py \
1411         tools/ganeti-listrunner
1412
1413 pep8_python_code = \
1414         ganeti \
1415         ganeti/http/server.py \
1416         $(dist_sbin_SCRIPTS) \
1417         $(python_scripts) \
1418         $(pkglib_python_scripts) \
1419         $(BUILD_BASH_COMPLETION) \
1420         $(CHECK_HEADER) \
1421         $(DOCPP) \
1422         $(PYTHON_BOOTSTRAP) \
1423         qa
1424
1425 test/py/daemon-util_unittest.bash: daemons/daemon-util
1426
1427 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1428
1429 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1430
1431 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1432         sed -f $(REPLACE_VARS_SED) < $< > $@
1433         chmod +x $@
1434
1435 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1436         sed -f $(REPLACE_VARS_SED) < $< > $@
1437         chmod +x $@
1438
1439 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1440         sed -f $(REPLACE_VARS_SED) < $< > $@
1441         chmod +x $@
1442
1443 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1444         sed -f $(REPLACE_VARS_SED) < $< > $@
1445         chmod +x $@
1446
1447 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1448         sed -f $(REPLACE_VARS_SED) < $< > $@
1449         chmod +x $@
1450
1451 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1452         sed -f $(REPLACE_VARS_SED) < $< > $@
1453         chmod +x $@
1454
1455 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1456         sed -f $(REPLACE_VARS_SED) < $< > $@
1457
1458 doc/examples/bash_completion: BC_ARGS = --compact
1459 doc/examples/bash_completion-debug: BC_ARGS =
1460
1461 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1462         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1463         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1464         daemons/ganeti-cleaner \
1465         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1466         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1467           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1468
1469 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1470         lib/build/shell_example_lexer.py \
1471         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1472         @echo "Checking $< for hardcoded paths..."
1473         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1474           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1475           exit 1; \
1476         fi
1477         set -e ; \
1478         trap 'echo auto-removing $@; rm $@' EXIT; \
1479         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1480         $(CHECK_MAN_REFERENCES) $@; \
1481         trap - EXIT
1482
1483 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1484         @test -n "$(PANDOC)" || \
1485           { echo 'pandoc' not found during configure; exit 1; }
1486         set -o pipefail -e; \
1487         trap 'echo auto-removing $@; rm $@' EXIT; \
1488         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1489           sed -e 's/\\@/@/g' > $@; \
1490         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1491         $(CHECK_MAN_DASHES) $@; \
1492         trap - EXIT
1493
1494 man/%.html.in: man/%.gen man/footer.rst
1495         @test -n "$(PANDOC)" || \
1496           { echo 'pandoc' not found during configure; exit 1; }
1497         set -o pipefail ; \
1498         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1499           sed -e 's/\\@/@/g' > $@
1500
1501 man/%: man/%.in  $(REPLACE_VARS_SED)
1502         sed -f $(REPLACE_VARS_SED) < $< > $@
1503
1504 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1505         sed -f $(REPLACE_VARS_SED) < $< > $@
1506
1507 vcs-version:
1508         if test -d .git; then \
1509           git describe > $@; \
1510         elif test ! -f $@ ; then \
1511           echo "Cannot auto-generate $@ file"; exit 1; \
1512         fi
1513
1514 .PHONY: clean-vcs-version
1515 clean-vcs-version:
1516         rm -f vcs-version
1517
1518 .PHONY: regen-vcs-version
1519 regen-vcs-version:
1520         @set -e; \
1521         cd $(srcdir); \
1522         if test -d .git; then \
1523           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1524           git describe > $$T; \
1525           if ! cmp --quiet $$T vcs-version; then \
1526             mv $$T vcs-version; \
1527           fi; \
1528         fi
1529
1530 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1531         vcs-version $(built_base_sources)
1532         set -e; \
1533         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1534         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1535
1536 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1537         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1538         lib/jstore.py $(RUN_IN_TEMPDIR) \
1539         $(CONVERT_CONSTANTS) $(built_base_sources) \
1540         | lib/_vcsversion.py
1541         set -e; \
1542         { cat $< ; \
1543           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1544         } > $@
1545
1546 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1547         hsc2hs -o $@ $<
1548
1549 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1550         $(built_base_sources)
1551         set -e; \
1552         { cat $< ; \
1553           echo ; \
1554           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1555             echo "import $$name ()" ; \
1556           done ; \
1557         } > $@
1558
1559 lib/_autoconf.py: Makefile | stamp-directories
1560         set -e; \
1561         { echo '# This file is automatically generated, do not edit!'; \
1562           echo '#'; \
1563           echo ''; \
1564           echo '"""Build-time configuration for Ganeti.'; \
1565           echo '';\
1566           echo 'This file is autogenerated by the build process.'; \
1567           echo 'For any changes you need to re-run ./configure (and'; \
1568           echo 'not edit by hand).'; \
1569           echo ''; \
1570           echo '"""'; \
1571           echo ''; \
1572           echo '# pylint: disable=C0301,C0324'; \
1573           echo '# because this is autogenerated, we do not want'; \
1574           echo '# style warnings' ; \
1575           echo ''; \
1576           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1577           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1578           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1579           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1580           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1581           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1582           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1583           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1584           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1585           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1586           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1587           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1588           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1589           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1590           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1591           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1592           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1593           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1594           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1595           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1596           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1597           echo "KVM_PATH = '$(KVM_PATH)'"; \
1598           echo "IP_PATH = '$(IP_PATH)'"; \
1599           echo "SOCAT_PATH = '$(SOCAT)'"; \
1600           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1601           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1602           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1603           echo "TOOLSDIR = '$(toolsdir)'"; \
1604           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1605           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1606           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1607           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1608           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1609           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1610           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1611           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1612           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1613           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1614           echo "RAPI_USER = '$(RAPI_USER)'"; \
1615           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1616           echo "CONFD_USER = '$(CONFD_USER)'"; \
1617           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1618           echo "LUXID_USER = '$(LUXID_USER)'"; \
1619           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1620           echo "NODED_USER = '$(NODED_USER)'"; \
1621           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1622           echo "MOND_USER = '$(MOND_USER)'"; \
1623           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1624           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1625           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1626           echo "HTOOLS = True"; \
1627           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1628           echo "XEN_CMD = '$(XEN_CMD)'"; \
1629           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1630           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1631           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1632 ## Write dictionary with man page name as the key and the section number as the
1633 ## value
1634           echo "MAN_PAGES = {"; \
1635           for i in $(notdir $(man_MANS)); do \
1636             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1637           done; \
1638           echo "}"; \
1639         } > $@
1640
1641 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1642         set -e; \
1643         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1644         { echo '# This file is automatically generated, do not edit!'; \
1645           echo '#'; \
1646           echo ''; \
1647           echo '"""Build-time VCS version number for Ganeti.'; \
1648           echo '';\
1649           echo 'This file is autogenerated by the build process.'; \
1650           echo 'For any changes you need to re-run ./configure (and'; \
1651           echo 'not edit by hand).'; \
1652           echo ''; \
1653           echo '"""'; \
1654           echo ''; \
1655           echo '# pylint: disable=C0301,C0324'; \
1656           echo '# because this is autogenerated, we do not want'; \
1657           echo '# style warnings' ; \
1658           echo ''; \
1659           echo "VCS_VERSION = '$$VCSVER'"; \
1660         } > $@
1661
1662 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1663         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1664
1665 $(SHELL_ENV_INIT): Makefile stamp-directories
1666         set -e; \
1667         { echo '# Allow overriding for tests'; \
1668           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1669           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1670           echo; \
1671           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1672           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1673           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1674           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1675           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1676         } > $@
1677
1678 ## Writes sed script to replace placeholders with build-time values. The
1679 ## additional quotes after the first @ sign are necessary to stop configure
1680 ## from replacing those values as well.
1681 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1682         set -e; \
1683         { echo 's#@''PREFIX@#$(prefix)#g'; \
1684           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1685           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1686           echo 's#@''BINDIR@#$(bindir)#g'; \
1687           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1688           echo 's#@''LIBDIR@#$(libdir)#g'; \
1689           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1690           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1691           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1692           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1693           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1694           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1695           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1696           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1697           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1698           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1699           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1700           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1701           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1702           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1703           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1704           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1705           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1706           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1707           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1708           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1709           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1710           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1711           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1712           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1713           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1714           echo; \
1715           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1716           echo '  r $(SHELL_ENV_INIT)'; \
1717           echo '  d'; \
1718           echo '}'; \
1719         } > $@
1720
1721 # Using deferred evaluation
1722 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1723 daemons/ganeti-watcher: MODULE = ganeti.watcher
1724 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1725 tools/burnin: MODULE = ganeti.tools.burnin
1726 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1727 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1728 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1729 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1730 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1731
1732 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1733         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1734         set -e; \
1735         { echo '#!/usr/bin/python'; \
1736           echo '# This file is automatically generated, do not edit!'; \
1737           echo "# Edit $(MODULE) instead."; \
1738           echo; \
1739           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1740           echo; \
1741           echo '# pylint: disable=C0103'; \
1742           echo '# C0103: Invalid name'; \
1743           echo; \
1744           echo 'import sys'; \
1745           echo 'import $(MODULE) as main'; \
1746           echo; \
1747           echo '# Temporarily alias commands until bash completion'; \
1748           echo '# generator is changed'; \
1749           echo 'if hasattr(main, "commands"):'; \
1750           echo '  commands = main.commands # pylint: disable=E1101'; \
1751           echo 'if hasattr(main, "aliases"):'; \
1752           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1753           echo; \
1754           echo 'if __name__ == "__main__":'; \
1755           echo '  sys.exit(main.Main())'; \
1756         } > $@
1757         chmod u+x $@
1758
1759 $(HS_BUILT_TEST_HELPERS): Makefile
1760         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1761         set -e; \
1762         { echo '#!/bin/sh'; \
1763           echo '# This file is automatically generated, do not edit!'; \
1764           echo "# Edit Makefile.am instead."; \
1765           echo; \
1766           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1767         } > $@
1768         chmod u+x $@
1769
1770 stamp-directories: Makefile
1771         $(MAKE) $(AM_MAKEFLAGS) ganeti
1772         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1773         touch $@
1774
1775 # We need to create symlinks because "make distcheck" will not install Python
1776 # files when building.
1777 stamp-srclinks: Makefile | stamp-directories
1778         set -e; \
1779         for i in $(srclink_files); do \
1780           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1781             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1782           fi; \
1783         done
1784         touch $@
1785
1786 .PHONY: ganeti
1787 ganeti:
1788         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1789
1790 .PHONY: check-dirs
1791 check-dirs: $(GENERATED_FILES)
1792         @set -e; \
1793         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1794           error=; \
1795           while read dir; do \
1796             case "$$dir" in \
1797               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1798               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1799             esac; \
1800           done; \
1801           for dir in $(DIRS); do \
1802             if ! test -d "$$dir"; then \
1803               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1804               error=1; \
1805             fi \
1806           done; \
1807           test -z "$$error"; \
1808         }
1809
1810 .PHONY: check-local
1811 check-local: check-dirs $(GENERATED_FILES)
1812         $(CHECK_PYTHON_CODE) $(check_python_code)
1813         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1814         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1815         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1816         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1817         error= ; \
1818         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1819           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1820           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1821             echo "Incorrect version in README, expected $$expver" >&2; \
1822             error=1; \
1823           fi; \
1824           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1825               doc/security.rst; do \
1826             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1827               "Documents Ganeti version $$expver"; then \
1828               echo "Incorrect version in $$file, expected $$expver" >&2; \
1829               error=1; \
1830             fi; \
1831           done; \
1832           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1833             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1834             error=1; \
1835           fi; \
1836           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1837             ".. Last updated for Ganeti $$expver"; then \
1838             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1839             error=1; \
1840           fi; \
1841         fi; \
1842         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1843           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1844             echo "Longest line in $$file is longer than 80 characters" >&2; \
1845             error=1; \
1846           fi; \
1847         done; \
1848         test -z "$$error"
1849
1850 .PHONY: hs-test-%
1851 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1852         @rm -f htest.tix
1853         test/hs/htest -t $*
1854
1855 .PHONY: hs-tests
1856 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1857         @rm -f htest.tix
1858         ./test/hs/htest
1859
1860 .PHONY: hs-shell-%
1861 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
1862             $(HS_BUILT_TEST_HELPERS)
1863         @rm -f hpc-htools.tix hpc-mon-collector.tix
1864         HBINARY="./test/hs/hpc-htools" \
1865         SHELLTESTARGS=$(SHELLTESTARGS) \
1866         ./test/hs/offline-test.sh $*
1867
1868 .PHONY: hs-shell
1869 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1870         @rm -f hpc-htools.tix hpc-mon-collector.tix
1871         HBINARY="./test/hs/hpc-htools" \
1872         SHELLTESTARGS=$(SHELLTESTARGS) \
1873         ./test/hs/offline-test.sh
1874
1875 .PHONY: hs-check
1876 hs-check: hs-tests hs-shell
1877
1878 # E111: indentation is not a multiple of four
1879 # E121: continuation line indentation is not a multiple of four
1880 #       (since our indent level is not 4)
1881 # E125: continuation line does not distinguish itself from next logical line
1882 #       (since our indent level is not 4)
1883 # E127: continuation line over-indented for visual indent
1884 #       (since our indent level is not 4)
1885 # note: do NOT add E128 here; it's a valid style error in most cases!
1886 # I've seen real errors, but also some cases were we indent wrongly
1887 # due to line length; try to rework the cases where it is triggered,
1888 # instead of silencing it
1889 # E261: at least two spaces before inline comment
1890 # E501: line too long (80 characters)
1891 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1892
1893 # For excluding pep8 expects filenames only, not whole paths
1894 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1895
1896 LINT_TARGETS = pylint pylint-qa
1897 if HAS_PEP8
1898 LINT_TARGETS += pep8
1899 endif
1900 if HAS_HLINT
1901 LINT_TARGETS += hlint
1902 endif
1903
1904 .PHONY: lint
1905 lint: $(LINT_TARGETS)
1906
1907 .PHONY: pylint
1908 pylint: $(GENERATED_FILES)
1909         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1910         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1911
1912 .PHONY: pylint-qa
1913 pylint-qa: $(GENERATED_FILES)
1914         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1915         cd $(top_srcdir)/qa && \
1916           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1917           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1918
1919 .PHONY: pep8
1920 pep8: $(GENERATED_FILES)
1921         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1922         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1923           --repeat $(pep8_python_code)
1924
1925 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1926 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1927 .PHONY: hlint
1928 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1929         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1930         @rm -f doc/hs-lint.html
1931         if tty -s; then C="-c"; else C=""; fi; \
1932         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1933           --ignore "Use first" \
1934           --ignore "Use &&&" \
1935           --ignore "Use void" \
1936           --ignore "Reduce duplication" \
1937           --hint src/lint-hints \
1938           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1939         @if [ ! -f doc/hs-lint.html ]; then \
1940           echo "All good" > doc/hs-lint.html; \
1941         fi
1942
1943 # a dist hook rule for updating the vcs-version file; this is
1944 # hardcoded due to where it needs to build the file...
1945 dist-hook:
1946         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1947         rm -f $(top_distdir)/vcs-version
1948         cp -p $(srcdir)/vcs-version $(top_distdir)
1949
1950 # a distcheck hook rule for catching revision control directories
1951 distcheck-hook:
1952         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1953           echo "Found revision control files in final archive." 1>&2; \
1954           exit 1; \
1955         fi
1956         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1957           echo "Found Python byte code in final archive." 1>&2; \
1958           exit 1; \
1959         fi
1960         if find $(top_distdir) -name '*~' | grep .; then \
1961           echo "Found backup files in final archive." 1>&2; \
1962           exit 1; \
1963         fi
1964 # Empty files or directories should not be distributed. They can cause
1965 # unnecessary warnings for packagers. Directories used by automake during
1966 # distcheck must be excluded.
1967         if find $(top_distdir) -empty -and -not \( \
1968             -path $(top_distdir)/_build -or \
1969             -path $(top_distdir)/_inst \) | grep .; then \
1970           echo "Found empty files or directories in final archive." 1>&2; \
1971           exit 1; \
1972         fi
1973         if test -e $(top_distdir)/doc/man-html; then \
1974           echo "Found documentation including man pages in final archive" >&2; \
1975           exit 1; \
1976         fi
1977
1978 # Backwards compatible distcheck-release target
1979 distcheck-release: distcheck
1980
1981 distrebuildcheck: dist
1982         set -e; \
1983         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1984         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1985         cd $$builddir; \
1986         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1987         cd $(distdir); \
1988         ./configure; \
1989         $(MAKE) maintainer-clean; \
1990         cp $(abs_srcdir)/vcs-version .; \
1991         ./configure; \
1992         $(MAKE) $(AM_MAKEFLAGS)
1993
1994 dist-release: dist
1995         set -e; \
1996         for i in $(DIST_ARCHIVES); do \
1997           echo -n "Checking $$i ... "; \
1998           autotools/check-tar < $$i; \
1999           echo OK; \
2000         done
2001
2002 install-exec-local:
2003         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
2004           "$(DESTDIR)${localstatedir}/log/ganeti" \
2005           "$(DESTDIR)${localstatedir}/run/ganeti"
2006
2007 .PHONY: apidoc
2008 if WANT_HSAPIDOC
2009 apidoc: py-apidoc hs-apidoc
2010 else
2011 apidoc: py-apidoc
2012 endif
2013
2014 .PHONY: py-apidoc
2015 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
2016         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
2017         $(RUN_IN_TEMPDIR) epydoc -v \
2018           --conf $(CURDIR)/epydoc.conf \
2019           --output $(CURDIR)/$(APIDOC_PY_DIR)
2020
2021 .PHONY: hs-apidoc
2022 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2023
2024 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2025         @test -n "$(HSCOLOUR)" || \
2026             { echo 'HsColour' not found during configure; exit 1; }
2027         @test -n "$(HADDOCK)" || \
2028             { echo 'haddock' not found during configure; exit 1; }
2029         rm -rf $(APIDOC_HS_DIR)/*
2030         for i in $(ALL_APIDOC_HS_DIRS); do \
2031           @mkdir_p@ $$i; \
2032           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2033         done
2034         set -e ; \
2035         export LC_ALL=en_US.UTF-8; \
2036         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2037         if [ "$(HS_PARALLEL3)" ]; \
2038         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2039         fi; \
2040         if [ "$(HS_REGEX_PCRE)" ]; \
2041         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2042         fi; \
2043         for file in $(HS_LIBTESTBUILT_SRCS); do \
2044           f_nosrc=$${file##src/}; \
2045           f_notst=$${f_nosrc##test/hs/}; \
2046           f_html=$${f_notst%%.hs}.html; \
2047           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2048         done ; \
2049         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2050           -t ganeti -p src/haddock-prologue \
2051           --source-module="%{MODULE/.//}.html" \
2052           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2053           $$OPTGHC \
2054           $(HS_LIBTESTBUILT_SRCS)
2055
2056 .PHONY: TAGS
2057 TAGS: $(GENERATED_FILES)
2058         rm -f TAGS
2059         $(GHC) -e ":etags" -v0 \
2060           $(filter-out -O -Werror,$(HFLAGS)) \
2061           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2062           $(HS_LIBTEST_SRCS)
2063         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2064           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2065           -path './qa/*.py' | \
2066           etags -l python -a -
2067
2068 .PHONY: coverage
2069
2070 COVERAGE_TESTS=
2071 if WANT_HTOOLS
2072 COVERAGE_TESTS += hs-coverage
2073 endif
2074 if PY_UNIT
2075 COVERAGE_TESTS += py-coverage
2076 endif
2077
2078 coverage: $(COVERAGE_TESTS)
2079
2080 .PHONY: py-coverage
2081 py-coverage: $(GENERATED_FILES) $(python_tests)
2082         @test -n "$(PYCOVERAGE)" || \
2083             { echo 'python-coverage' not found during configure; exit 1; }
2084         set -e; \
2085         COVERAGE=$(PYCOVERAGE) \
2086         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2087         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2088         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2089         $(PLAIN_TESTS_ENVIRONMENT) \
2090         $(abs_top_srcdir)/autotools/gen-py-coverage \
2091         $(python_tests)
2092
2093 .PHONY: hs-coverage
2094 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2095         rm -f *.tix
2096         $(MAKE) $(AM_MAKEFLAGS) hs-check
2097         @mkdir_p@ $(COVERAGE_HS_DIR)
2098         hpc sum --union $(HPCEXCL) \
2099           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2100         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2101         hpc report coverage-hs.tix
2102         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2103
2104 # Special "kind-of-QA" target for htools, needs special setup (all
2105 # tools compiled with -fhpc)
2106 .PHONY: live-test
2107 live-test: all
2108         set -e ; \
2109         cd src; \
2110         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2111         rm -f *.tix *.mix; \
2112         ./live-test.sh; \
2113         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2114           --output=live-test.tix ; \
2115         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2116         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2117           --srcdir=.. $(HPCEXCL) ; \
2118         hpc report --srcdir=.. live-test $(HPCEXCL)
2119
2120 commit-check: autotools-check distcheck lint apidoc
2121
2122 autotools-check:
2123         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2124   $(abs_top_srcdir)/test/autotools/*-*.test \
2125   -- --hide-successes
2126
2127 .PHONY: gitignore-check
2128 gitignore-check:
2129         @if [ -n "`git status --short`" ]; then \
2130           echo "Git status is not clean!" 1>&2 ; \
2131           git status --short; \
2132           exit 1; \
2133         fi
2134
2135 # target to rebuild all man pages (both groff and html output)
2136 .PHONY: man
2137 man: $(man_MANS) $(manhtml)
2138
2139 # Target that builds all binaries (including those that are not
2140 # rebuilt except when running the tests)
2141 .PHONY: really-all
2142 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2143
2144 # we don't need the ancient implicit rules:
2145 %: %,v
2146 %: RCS/%,v
2147 %: RCS/%
2148 %: s.%
2149 %: SCCS/s.%
2150
2151 -include ./Makefile.local
2152
2153 # vim: set noet :